package cn.iocoder.yudao.module.pms.service.iotwebtopodevicesvgnode;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.ObjUtil;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotwebtopodevicesvgnode.vo.IotWebtopoDeviceSvgnodePageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotwebtopodevicesvgnode.vo.IotWebtopoDeviceSvgnodeSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotwebtopodevicesvgnode.IotWebtopoDeviceSvgnodeDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotwebtopodevicesvgnode.IotWebtopoDeviceSvgnodeMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import java.util.Collections;
import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_WEBTOPO_DEVICE_SVGNODE_EXISTS;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_WEBTOPO_DEVICE_SVGNODE_NOT_EXISTS;

/**
 * 组态-svg与设备绑定 Service 实现类
 *
 * @author ruiqi
 */
@Service
@Validated
public class IotWebtopoDeviceSvgnodeServiceImpl implements IotWebtopoDeviceSvgnodeService {

    @Resource
    private IotWebtopoDeviceSvgnodeMapper iotWebtopoDeviceSvgnodeMapper;

    @Override
    public Long createIotWebtopoDeviceSvgnode(IotWebtopoDeviceSvgnodeSaveReqVO createReqVO) {
        if (ObjUtil.isEmpty(createReqVO)) {
            throw exception(IOT_WEBTOPO_DEVICE_SVGNODE_NOT_EXISTS);
        }
        // deviceId-svgNodeId-svgNodeProp 唯一标识
        // 查询是否已经存在 3个属性的联合唯一键值
        IotWebtopoDeviceSvgnodePageReqVO reqVO = new IotWebtopoDeviceSvgnodePageReqVO();
        reqVO.setDeviceId(createReqVO.getDeviceId());
        reqVO.setSvgNodeId(createReqVO.getSvgNodeId());
        reqVO.setSvgNodeProp(createReqVO.getSvgNodeProp());
        reqVO.setPageSize(PageParam.PAGE_SIZE_NONE);
        PageResult<IotWebtopoDeviceSvgnodeDO> pageResult = iotWebtopoDeviceSvgnodeMapper.selectPage(reqVO);
        if (ObjUtil.isNotEmpty(pageResult)) {
            List<IotWebtopoDeviceSvgnodeDO> deviceSvgNodes = pageResult.getList();
            if (CollUtil.isNotEmpty(deviceSvgNodes)) {
                throw exception(IOT_WEBTOPO_DEVICE_SVGNODE_EXISTS);
            }
        }
        // 插入
        IotWebtopoDeviceSvgnodeDO iotWebtopoDeviceSvgnode = BeanUtils.toBean(createReqVO, IotWebtopoDeviceSvgnodeDO.class);
        iotWebtopoDeviceSvgnodeMapper.insert(iotWebtopoDeviceSvgnode);
        // 返回
        return iotWebtopoDeviceSvgnode.getId();
    }

    @Override
    public void updateIotWebtopoDeviceSvgnode(IotWebtopoDeviceSvgnodeSaveReqVO updateReqVO) {
        // 校验存在
        validateIotWebtopoDeviceSvgnodeExists(updateReqVO.getId());
        // deviceId-svgNodeId-svgNodeProp 唯一标识
        // 查询是否已经存在 3个属性的联合唯一键值
        IotWebtopoDeviceSvgnodePageReqVO reqVO = new IotWebtopoDeviceSvgnodePageReqVO();
        reqVO.setDeviceId(updateReqVO.getDeviceId());
        reqVO.setSvgNodeId(updateReqVO.getSvgNodeId());
        reqVO.setSvgNodeProp(updateReqVO.getSvgNodeProp());
        reqVO.setPageSize(PageParam.PAGE_SIZE_NONE);
        PageResult<IotWebtopoDeviceSvgnodeDO> pageResult = iotWebtopoDeviceSvgnodeMapper.selectPage(reqVO);
        if (ObjUtil.isNotEmpty(pageResult)) {
            List<IotWebtopoDeviceSvgnodeDO> deviceSvgNodes = pageResult.getList();
            if (CollUtil.isNotEmpty(deviceSvgNodes)) {
                deviceSvgNodes.forEach(node -> {
                    if (!node.getId().equals(updateReqVO.getId())) {
                        throw exception(IOT_WEBTOPO_DEVICE_SVGNODE_EXISTS);
                    }
                });
            }
        }
        // 更新
        IotWebtopoDeviceSvgnodeDO updateObj = BeanUtils.toBean(updateReqVO, IotWebtopoDeviceSvgnodeDO.class);
        iotWebtopoDeviceSvgnodeMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotWebtopoDeviceSvgnode(Long id) {
        // 校验存在
        validateIotWebtopoDeviceSvgnodeExists(id);
        // 删除
        iotWebtopoDeviceSvgnodeMapper.deleteById(id);
    }

    private void validateIotWebtopoDeviceSvgnodeExists(Long id) {
        if (iotWebtopoDeviceSvgnodeMapper.selectById(id) == null) {
            throw exception(IOT_WEBTOPO_DEVICE_SVGNODE_NOT_EXISTS);
        }
    }

    @Override
    public IotWebtopoDeviceSvgnodeDO getIotWebtopoDeviceSvgnode(Long id) {
        return iotWebtopoDeviceSvgnodeMapper.selectById(id);
    }

    @Override
    public PageResult<IotWebtopoDeviceSvgnodeDO> getIotWebtopoDeviceSvgnodePage(IotWebtopoDeviceSvgnodePageReqVO pageReqVO) {
        return iotWebtopoDeviceSvgnodeMapper.selectPage(pageReqVO);
    }
}